searchData={"items":[{"type":"module","title":"Quex","doc":"Quex\n====\n\nSimple queue implementation, based on Erlang's queue module, which is\nan efficient implementation of double ended fifo queues\n\nDifferences between Quex and Erlang's queue module are a more Elixir\nfriendly API (subject as first argument) and implementations of the\n`Enumerable`, `Collectable` and `Inspect` protocols.","ref":"Quex.html"},{"type":"module","title":"Examples - Quex","doc":"```elixir\niex> q = Quex.new |> Quex.put(1) |> Quex.put(2)\nQuex.new([1, 2])\niex> Quex.pop(q)\n{1, Quex.new([2])}\n\niex> Quex.new([1, 2, 3, 4]) |> Enum.take_while(&(&1 < 3))\n[1, 2]\n\niex> for n <- 1..4, into: Quex.new(), do: n * n\nQuex.new([1, 4, 9, 16])\n```","ref":"Quex.html#module-examples"},{"type":"function","title":"Quex.drop/1","doc":"Remove the first value from the front of the queue\n\nReturns the rest of the queue or `:empty` if the queue has no items.","ref":"Quex.html#drop/1"},{"type":"function","title":"Quex.drop_rear/1","doc":"Remove the last value from the rear of the queue\n\nReturns the rest of the queue or `:empty` if the queue has no items.","ref":"Quex.html#drop_rear/1"},{"type":"function","title":"Quex.from_erl/1","doc":"Converts Erlang's queue data type to a queue","ref":"Quex.html#from_erl/1"},{"type":"function","title":"Quex.join/2","doc":"Join two queues\n\nIt effectively appends the second queue to the first queue.","ref":"Quex.html#join/2"},{"type":"function","title":"Quex.member?/2","doc":"Returns true if the given value exists in the queue","ref":"Quex.html#member?/2"},{"type":"function","title":"Quex.new/0","doc":"Creates a new empty queue","ref":"Quex.html#new/0"},{"type":"function","title":"Quex.new/1","doc":"Creates a new queue from a list\n\nThe first element in the list will be the front item of the queue.","ref":"Quex.html#new/1"},{"type":"function","title":"Quex.peek/1","doc":"Get the first value from the front of the queue without removing it\n\nReturns the `{:ok, value}` or `:empty` if the queue has no items.","ref":"Quex.html#peek/1"},{"type":"function","title":"Quex.peek_rear/1","doc":"Get the last value from the rear of the queue without removing it\n\nReturns the `{:ok, value}` or `:empty` if the queue has no items.","ref":"Quex.html#peek_rear/1"},{"type":"function","title":"Quex.pop/1","doc":"Pop the first value from the front of the queue\n\nReturns the value as well the rest of the queue or `:empty` if the queue has\nno items.","ref":"Quex.html#pop/1"},{"type":"function","title":"Quex.pop_rear/1","doc":"Pop the last value from the rear of the queue\n\nReturns the value as well the rest of the queue or `:empty` if the queue has\nno items.","ref":"Quex.html#pop_rear/1"},{"type":"function","title":"Quex.put/2","doc":"Puts the given value at the end the queue","ref":"Quex.html#put/2"},{"type":"function","title":"Quex.put_front/2","doc":"Puts the given value at the front of the queue\n\nThis means that it will be the first item in the queue to pop, peek, or drop.","ref":"Quex.html#put_front/2"},{"type":"function","title":"Quex.size/1","doc":"Returns the number of items in the queue","ref":"Quex.html#size/1"},{"type":"type","title":"Quex.t/0","doc":"","ref":"Quex.html#t:t/0"},{"type":"function","title":"Quex.to_erl/1","doc":"Converts a queue to Erlang's queue data type","ref":"Quex.html#to_erl/1"},{"type":"function","title":"Quex.to_list/1","doc":"Converts a queue to a list\n\nThe front item of the queue will be the first element in the list.","ref":"Quex.html#to_list/1"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}